Magellan Linux

Diff of /trunk/grubby/new-kernel-pkg

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mkinitrd-magellan/grubby/new-kernel-pkg revision 532 by niro, Sat Sep 1 22:45:15 2007 UTC trunk/grubby/new-kernel-pkg revision 2239 by niro, Mon Oct 21 13:28:04 2013 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3  #  #
4    # new-kernel-pkg
5  # Invoked upon installation or removal of a kernel package, the following  # Invoked upon installation or removal of a kernel package, the following
6  # tasks are/can be done here:  # tasks are/can be done here:
7  # creation/removal of initrd  # creation/removal of initrd
8  # run of depmod/removal of depmod generated files  # run of depmod/removal of depmod generated files
9  # addition/removal of kernel images from grub/lilo configuration (via grubby)  # addition/removal of kernel images from grub/lilo configuration (via grubby)
10  #  #
11  # Copyright (C) 2002-2005 Red Hat, Inc.  # Copyright 2002-2008 Red Hat, Inc.  All rights reserved.
 #  
12  # modified for Magellan-Linux by Niels Rogalla <niro@magellan-linux.de>  # modified for Magellan-Linux by Niels Rogalla <niro@magellan-linux.de>
13  #  #
14    # This program is free software; you can redistribute it and/or modify
15    # it under the terms of the GNU General Public License as published by
16    # the Free Software Foundation; either version 2 of the License, or
17    # (at your option) any later version.
18    #
19    # This program is distributed in the hope that it will be useful,
20    # but WITHOUT ANY WARRANTY; without even the implied warranty of
21    # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
22    # GNU General Public License for more details.
23    #
24    # You should have received a copy of the GNU General Public License
25    # along with this program.  If not, see <http://www.gnu.org/licenses/>.
26    #
27    
28    read_os_release()
29    {
30     local NAME
31     local ID
32     local Version
33     local Version_ID
34     local PRETTY_NAME
35     local ANSI_COLOR
36     local CPE_NAME
37    
38     if [[ -f /etc/os-release ]]
39     then
40     source /etc/os-release
41    
42     case $1 in
43     name) echo "${NAME}" ;;
44     id) echo "${ID}" ;;
45     version) echo "${Version}" ;;
46     version_id) echo "${Version_ID}" ;;
47     pretty_name) echo "${PRETTY_NAME}" ;;
48     ansi_color) echo "${ANSI_COLOR}" ;;
49     cpe_name) echo "${CPE_NAME}" ;;
50     esac
51     fi
52    }
53    
54  PATH=/sbin:/bin:$PATH  PATH=/sbin:/bin:$PATH
55    
# Line 18  lilo=/sbin/lilo Line 58  lilo=/sbin/lilo
58  # some defaults that are sane for most arches  # some defaults that are sane for most arches
59  kernelName=kernel  kernelName=kernel
60    
61  if [ -x ./grubby ]; then  if [ -x ./grubby ]
62      grubby=./grubby  then
63     grubby=./grubby
64  else  else
65      grubby=/sbin/grubby   grubby=/sbin/grubby
66  fi  fi
67    
68  [ -f /etc/sysconfig/kernel ] && . /etc/sysconfig/kernel  [ -f /etc/conf.d/grubby ] && . /etc/conf.d/grubby
69    [ -f /etc/conf.d/grubby-uboot ] && . /etc/conf.d/grubby-uboot
70    
71    cfgGrub2=""
72    cfgGrub2Efi=""
73  cfgGrub=""  cfgGrub=""
74  cfgLilo=""  cfgLilo=""
75    cfgExtlinux=""
76    cfguBoot=""
77  runLilo=""  runLilo=""
78  grubConfig=""  grubConfig=""
79    grub2Config=""
80    grub2EfiConfig=""
81    extlinuxConfig=""
82    
83  ARCH=$(uname -m)  ARCH=$(uname -m)
84    
85  if [ $ARCH = 'ia64' ]; then  if [[ ${ARCH} = ia64 ]]
86      liloConfig=/boot/efi/EFI/redhat/elilo.conf  then
87      bootPrefix=/boot/efi/EFI/redhat   liloConfig=/boot/efi/EFI/redhat/elilo.conf
88      liloFlag=elilo   bootPrefix=/boot/efi/EFI/redhat
89      isx86=""   liloFlag=elilo
90  elif [ $ARCH = 'ppc64' -o $ARCH = 'ppc' ]; then   isx86=""
91      liloConfig=/etc/yaboot.conf  elif [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
92      bootPrefix=/boot  then
93      lilo=/sbin/ybin   liloConfig=/etc/yaboot.conf
94      liloFlag=yaboot   grub2Config=/boot/grub/grub.cfg
95      runLilo="yes"   bootPrefix=/boot
96      isx86=""   lilo=/sbin/ybin
97  elif [ $ARCH = 'sparc' -o $ARCH = 'sparc64' ]; then   liloFlag=yaboot
98      liloConfig=/etc/silo.conf   runLilo="yes"
99      bootPrefix=/boot   isx86=""
100      liloFlag=silo  elif [[ ${ARCH} = sparc ]] || [[ ${ARCH} = sparc64 ]]
101      lilo=/sbin/silo  then
102      isx86=""   liloConfig=/etc/silo.conf
103  elif [ $ARCH = 's390' -o $ARCH = 's390x' ]; then   bootPrefix=/boot
104      liloConfig=/etc/zipl.conf   liloFlag=silo
105      bootPrefix=/boot   lilo=/sbin/silo
106      liloFlag=zipl   isx86=""
107      lilo=/sbin/zipl  elif [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
108      runLilo="yes"  then
109      isx86=""   liloConfig=/etc/zipl.conf
110     bootPrefix=/boot
111     liloFlag=zipl
112     lilo=/sbin/zipl
113     runLilo="yes"
114     isx86=""
115    elif [[ ${ARCH} =~ armv[5|7].*l ]]
116    then
117     liloConfig=""
118     bootPrefix=/boot
119     ubootDir=${UBOOT_DIR:-"/boot"}
120     ubootScript=$ubootDir/${UBOOT_SCR:-"boot.scr"}
121     ubootKList=${UBOOT_KLIST:-"klist.txt"}
122     ubootDevice=/dev/${UBOOT_DEVICE:-"mmcblk0p1"}
123     ubootDefaultImage=${UBOOT_UIMAGE:-"uImage"}
124     ubootDefaultInitrd=${UBOOT_UINITRD:-"uInitrd"}
125     ubootAddress=${UBOOT_IMGADDR:-"0x00008000"}
126     mounted=""
127     liloFlag=""
128     isx86=""
129  else  else
130      # this leaves i?86 and x86_64   # this leaves i?86 and x86_64
131      liloConfig=/etc/lilo.conf   liloConfig=/etc/lilo.conf
132      grubConfig=/boot/grub/grub.conf   grubConfig=/boot/grub/grub.conf
133      bootPrefix=/boot   grub2Config=/boot/grub/grub.cfg
134      liloFlag=lilo   grub2EfiConfig=/boot/grub/grub-efi.cfg
135      isx86="yes"   extlinuxConfig=/boot/extlinux/extlinux.conf
136     bootPrefix=/boot
137     liloFlag=lilo
138     isx86="yes"
139  fi  fi
140    
141  mode=""  mode=""
142  version=""  version=""
143  initrd=""  initrd=""
144    dracut=""
145    dracuthostonly=""
146  initrdfile=""  initrdfile=""
147  moddep=""  moddep=""
148  verbose=""  verbose=""
149  makedefault=""  makedefault=""
150  package=""  package=""
151  mbkernel=""  mbkernel="${HYPERVISOR}"
152  mbargs=""  mbargs="${HYPERVISOR_ARGS}"
153    adddracutargs=""
154    addplymouthinitrd=""
155    
156    usage()
157    {
158     echo "Usage: $(basename $0) [-v] [--mkinitrd] [--rminitrd] [--dracut]" >&2
159     echo "       [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2
160     echo "       [--kernel-args=<args>] [--remove-args=<args>]" >&2
161     echo "       [--banner=<banner>] [--multiboot=multiboot]" >&2
162     echo "       [--mbargs=mbargs] [--make-default] [--add-dracut-args]" >&2
163     echo "       [--add-plymouth-initrd]" >&2
164     echo "       [--host-only]" >&2
165     echo "       <--install | --remove | --update> <kernel-version>" >&2
166     echo "       (ex: $(basename $0) --mkinitrd --depmod --install 2.4.7-2)" >&2
167     exit 1
168    }
169    
170    install()
171    {
172     # XXX kernel should be able to be specified also (or work right on ia64)
173     if [ ! -f ${bootPrefix}/${kernelName}-${version} ]
174     then
175     [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
176     return
177     fi
178    
179     INITRD=""
180     if [ -f ${initrdfile} ]
181     then
182     [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
183     INITRD="--initrd ${initrdfile}"
184    
185     if [[ -n ${addplymouthinitrd} ]]
186     then
187     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
188     fi
189     fi
190    
191     # FIXME: is this a good heuristic to find out if we're on iSeries?
192     if [ -d /proc/iSeries ]
193     then
194     [[ -n ${verbose} ]] && echo "On an iSeries, just making img file"
195     if [[ -z ${initrdfile} ]]
196     then
197     [[ -n ${verbose} ]] && echo "No initrd, just adding system map"
198     /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${bootPrefix}/${kernelName}-${version} ${bootPrefix}/vmlinitrd-${version}
199     else
200     /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${bootPrefix}/${kernelName}-${version} ${bootPrefix}/vmlinux.sm-${version}
201     /sbin/addRamDisk ${initrdfile} ${bootPrefix}/System.map-${version} ${bootPrefix}/vmlinux.sm-${version} ${bootPrefix}/vmlinitrd-${version} 2>/dev/null
202     rm ${bootPrefix}/vmlinux.sm-${version}
203     fi
204     return
205     fi
206    
207     # get the root filesystem to use
208     rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab  2>/dev/null)
209     if [[ -z $rootdevice ]]
210     then
211     rootdevice=$(grep -o -P "(?<=root=)\S+" /proc/cmdline)
212     fi
213    
214     if [[ -n ${mbkernel} ]] && [[ -n ${cfgLilo} ]] && [[ ${liloFlag} != elilo ]]
215     then
216     [[ -n ${verbose} ]] && echo "multiboot specified, not updating lilo.conf"
217     cfgLilo=""
218     fi
219    
220     if [[ -n ${banner} ]]
221     then
222     title="${banner} [ ${version} ]"
223     elif [[ $(read_os_release id) = magellan ]]
224     then
225     title="$(read_os_release name) $(read_os_release version_id) [ ${version} ]"
226     elif [ -f /etc/mageversion ]
227     then
228     title="Magellan Linux $(< /etc/mageversion) [ ${version} ]"
229     else
230     title="Magellan Linux [ ${version} ]"
231     fi
232    
233     if [[ -n ${cfgGrub} ]]
234     then
235     [[ -n ${verbose} ]] && echo "adding ${version} to ${grubConfig}"
236    
237     ${grubby} --grub -c ${grubConfig} \
238     --add-kernel=${bootPrefix}/${kernelName}-${version} \
239     ${INITRD} --copy-default ${makedefault} --title "${title}" \
240     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
241     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
242     else
243     [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
244     fi
245     if [[ -n ${cfgGrub2} ]]
246     then
247     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2Config}"
248    
249     ${grubby} --grub2 -c ${grub2Config} \
250     --add-kernel=${bootPrefix}/${kernelName}-${version} \
251     ${INITRD} --copy-default ${makedefault} --title "${title}" \
252     ${mbkernel:+--add-multiboot="${mbkernel}"} \
253     ${mbargs:+--mbargs="${mbargs}"} \
254     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
255     else
256     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
257     fi
258     if [[ -n ${cfgGrub2Efi} ]]
259     then
260     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2EfiConfig}"
261    
262     ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
263     --add-kernel=${bootPrefix}/${kernelName}-${version} \
264     ${INITRD} --copy-default ${makedefault} --title "${title}" \
265     ${mbkernel:+--add-multiboot="${mbkernel}"} \
266     ${mbargs:+--mbargs="${mbargs}"} \
267     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
268     else
269     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby for grub 2 with UEFI"
270     fi
271    
272     if [[ -n ${cfgLilo} ]]
273     then
274     [[ -n ${verbose} ]] && echo "adding ${version} to ${liloConfig}"
275    
276     ${grubby} --add-kernel=${bootPrefix}/${kernelName}-${version} ${INITRD} \
277     --copy-default ${makedefault} --title ${version} \
278     ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
279     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${version}" \
280     --${liloFlag}
281    
282     if [[ -n ${runLilo} ]]
283     then
284     [[ -n ${verbose} ]] && echo "running ${lilo}"
285     if [ ! -x ${lilo} ]
286     then
287     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
288     else
289     ${lilo} > /dev/null
290     fi
291     fi
292     else
293     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
294     fi
295    
296  usage() {   if [[ -n ${cfgExtlinux} ]]
297      echo "Usage: `basename $0` [-v] [--mkinitrd] [--rminitrd]" >&2   then
298      echo "       [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2   [[ -n ${verbose} ]] && echo "adding ${version} to ${extlinuxConfig}"
299      echo "       [--kernel-args=<args>] [--banner=<banner>]" >&2  
300      echo "       [--multiboot=multiboot] [--mbargs=mbargs]" >&2   ${grubby} --extlinux -c ${extlinuxConfig} \
301      echo "       [--make-default] <--install | --remove> <kernel-version>" >&2   --add-kernel=${bootPrefix}/${kernelName}-${version} \
302      echo "       (ex: `basename $0` --mkinitrd --depmod --install 2.4.7-2)" >&2   ${INITRD} --copy-default ${makedefault} --title "${title}" \
303      exit 1   ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
304     --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
305     else
306     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
307     fi
308  }  }
309    
310  install() {  remove()
311      # XXX kernel should be able to be specified also (or work right on ia64)  {
312      if [ ! -f $bootPrefix/$kernelName-$version ] ; then   # FIXME: is this a good heuristic to find out if we're on iSeries?
313   [ -n "$verbose" ] && echo "kernel for $version does not exist, not running grubby"   if [ -d /proc/iSeries ]
314   return   then
315      fi   [[ -n ${verbose} ]] && echo "On an iSeries, remove img file"
316         rm -f ${bootPrefix}/${kernelName}-${version}.img 2>/dev/null
317      INITRD=""   return
318      if [ -f $initrdfile ]; then   fi
  [ -n "$verbose" ] && echo "found $initrdfile and using it with grubby"  
  INITRD="--initrd $initrdfile"  
     fi  
   
     # FIXME: is this a good heuristic to find out if we're on iSeries?  
     if [ -d /proc/iSeries ]; then  
  [ -n "$verbose" ] && echo "On an iSeries, just making img file"  
  if [ -z $initrdfile  ]; then  
     [ -n "$verbose" ] && echo "No initrd, just adding system map"  
     /sbin/addSystemMap $bootPrefix/System.map-$version $bootPrefix/$kernelName-$version $bootPrefix/vmlinitrd-$version  
  else  
     /sbin/addSystemMap $bootPrefix/System.map-$version $bootPrefix/$kernelName-$version $bootPrefix/vmlinux.sm-$version  
     /sbin/addRamDisk $initrdfile $bootPrefix/System.map-$version $bootPrefix/vmlinux.sm-$version $bootPrefix/vmlinitrd-$version 2>/dev/null  
     rm $bootPrefix/vmlinux.sm-$version  
  fi  
  return  
     fi  
   
     # get the root filesystem to use; if it's on a label make sure it's  
     # been configured. if not, get the root device from mount  
     rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab)  
     short=$(echo $rootdevice | cut -d= -f1)  
     if [ "$short" == "LABEL" ]; then  
  label=$(echo $rootdevice | cut -d= -f2 |head -n 1)  
  device=$(echo "showlabels" | /sbin/nash  --force --quiet |  
  awk '$2 == "'$label'" {print $1}')  
  if [ -z "$device" ]; then  
     rootdevice=$(mount | awk '$3 == "/" { print $1 }')  
  fi  
     fi  
   
     if [ -n "$mbkernel" ]; then  
  mb="--add-multiboot=$mbkernel"  
  if [ -n "$mbargs" ]; then  
     mb="$mb --mbargs=$mbargs"  
  fi  
  [ -n "$verbose" ] && echo "multiboot specified, not updating lilo.conf"  
  cfgLilo=""  
     fi  
   
     if [ -n "$cfgGrub" ]; then  
  [ -n "$verbose" ] && echo "adding $version to $grubConfig"  
   
  if [ -n "$banner" ]; then  
             title="$banner ($version)"  
  elif [ -f /etc/mageversion ]; then  
     title="Magellan Linux $(< /etc/mageversion) ($version)"  
  else  
     title="Magellan Linux ($version)"  
  fi  
  /sbin/grubby --add-kernel=$bootPrefix/$kernelName-$version $INITRD    \  
      --copy-default $makedefault $mb --title "$title"    \  
      --args="root=$rootdevice $kernargs"    \  
      --remove-kernel="TITLE=$title"                  
     else  
  [ -n "$verbose" ] && echo "$grubConfig does not exist, not running grubby"  
     fi  
   
     if [ -n "$cfgLilo" ]; then  
  [ -n "$verbose" ] && echo "adding $version to $liloConfig"  
   
  /sbin/grubby --add-kernel=$bootPrefix/$kernelName-$version $INITRD    \  
      --copy-default $makedefault --title $version    \  
      --args="root=$rootdevice $kernargs"    \  
      --remove-kernel="TITLE=$version"    \  
      --$liloFlag  
   
  if [ -n "$runLilo" ]; then  
     [ -n "$verbose" ] && echo "running $lilo"  
     if [ ! -x $lilo ] ; then  
  [ -n "$verbose" ] && echo "$lilo does not exist"  
     else  
  $lilo > /dev/null  
     fi  
  fi  
     else  
  [ -n "$verbose" ] && echo "$liloConfig does not exist, not running grubby"  
     fi  
319    
320     if [[ -n ${cfgGrub} ]]
321     then
322     [[ -n ${verbose} ]] && echo "removing ${version} from ${grubConfig}"
323     ${grubby} --grub -c ${grubConfig} \
324     --remove-kernel=${bootPrefix}/${kernelName}-${version}
325     else
326     [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
327     fi
328     if [[ -n ${cfgGrub2} ]]
329     then
330     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2Config}"
331     ${grubby} --grub2 -c ${grub2Config} \
332     --remove-kernel=${bootPrefix}/${kernelName}-${version}
333     else
334     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
335     fi
336     if [[ -n ${cfgGrub2Efi} ]]
337     then
338     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2EfiConfig}"
339     ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
340     --remove-kernel=${bootPrefix}/${kernelName}-${version}
341     else
342     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby grub 2 with UEFI"
343     fi
344    
345     if [[ -n ${cfgLilo} ]]
346     then
347     [[ -n ${verbose} ]] && echo "removing ${version} from ${liloConfig}"
348     ${grubby} --remove-kernel=${bootPrefix}/${kernelName}-${version} --${liloFlag}
349    
350     if [[ -n ${runLilo} ]]
351     then
352     [[ -n ${verbose} ]] && echo "running ${lilo}"
353     if [ ! -x ${lilo} ]
354     then
355     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
356     else
357     ${lilo} > /dev/null
358     fi
359     fi
360     else
361     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
362     fi
363    
364     if [[ -n ${cfguBoot} ]]
365     then
366     [[ -n ${verbose} ]] && echo "removing ${version} from ${ubootDir}..."
367    
368     if [ -f ${ubootDir}/${ubootKList} ]
369     then
370     tmpKList=$(mktemp ${ubootDir}/${ubootKList}.XXXX)
371     curversion=$(tail -n1 ${ubootDir}/${ubootKList})
372     sed "/$version$/d" ${ubootDir}/${ubootKList} > ${tmpKList}
373     newversion=$(tail -n1 ${tmpKList})
374     if [ -f ${ubootDir}/uImage-${newversion} ] && [ -f ${ubootDir}/uInitrd-${newversion} ]
375     then
376     if [[ ${curversion} != ${newversion} ]]
377     then
378     cp -fp ${ubootDir}/uImage-${newversion} ${ubootDir}/${ubootDefaultImage}
379     if [ $? -ne 0 ]
380     then
381     [[ -n ${verbose} ]] && echo "copy uImage-${newversion} error, default kernel not replaced!" && exit
382     fi
383     cp -fp ${ubootDir}/uInitrd-${newversion} ${ubootDir}/${ubootDefaultInitrd}
384     if [ $? -ne 0 ]
385     then
386     [[ -n ${verbose} ]] && echo "copy uInitrd-${newversion} error, default Initrd not replaced!" && exit
387     fi
388     fi
389    
390     [[ -n ${verbose} ]] && echo "removing uImage-${version}"
391     if [ -f ${ubootDir}/uImage-${version} ]
392     then
393     rm -f ${ubootDir}/uImage-${version}
394     else
395     [[ -n ${verbose} ]] && echo "uImage-${version} did not exist!"
396     fi
397    
398     [[ -n ${verbose} ]] && echo "removing uInitrd-${version}"
399     if [ -f ${ubootDir}/uInitrd-${version} ]
400     then
401     rm -f ${ubootDir}/uInitrd-${version}
402     else
403     [[ -n ${verbose} ]] && echo "uInitrd-${version} did not exist!"
404     fi
405    
406     mv ${tmpKList} ${ubootDir}/${ubootKList}
407     else
408     [[ -n ${verbose} ]] && echo "uImage ${newversion} does not exist!"
409     [ -f ${tmpKList} ] && rm -f ${tmpKList}
410     fi
411     else
412     [[ -n ${verbose} ]] && echo "No previous kernel version.  U-Boot images not removed!"
413     fi
414     else
415     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not modifying ${ubootDir}"
416     fi
417    
418     if [[ -n ${cfgExtlinux} ]]
419     then
420     [[ -n ${verbose} ]] && echo "removing ${version} from ${extlinuxConfig}"
421     ${grubby} --extlinux -c ${extlinuxConfig} \
422     --remove-kernel=${bootPrefix}/${kernelName}-${version}
423     else
424     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
425     fi
426  }  }
427    
428  remove() {  update()
429      # FIXME: is this a good heuristic to find out if we're on iSeries?  {
430      if [ -d /proc/iSeries ]; then   if [ ! -f ${bootPrefix}/${kernelName}-${version} ]
431   [ -n "$verbose" ] && echo "On an iSeries, remove img file"   then
432   rm -f $bootPrefix/$kernelName-$version.img 2>/dev/null   [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
433   return   return
434      fi   fi
435    
436      if [ -n "$cfgGrub" ]; then   INITRD=""
437   [ -n "$verbose" ] && echo "removing $version from $grubConfig"   if [ -f ${initrdfile} ]
438   /sbin/grubby --remove-kernel=$bootPrefix/$kernelName-$version   then
439      else   [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
440   [ -n "$verbose" ] && echo "$grubConfig does not exist, not running grubby"   INITRD="--initrd ${initrdfile}"
441      fi  
442     if [[ -n ${addplymouthinitrd} ]]
443      if [ -n "$cfgLilo" ]; then   then
444   [ -n "$verbose" ] && echo "removing $version from $liloConfig"   INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
445   /sbin/grubby --remove-kernel=$bootPrefix/$kernelName-$version    \   fi
446       --$liloFlag   fi
447    
448   if [ -n "$runLilo" ]; then   if [[ -n ${cfgGrub} ]]
449      [ -n "$verbose" ] && echo "running $lilo"   then
450      if [ ! -x $lilo ] ; then   [[ -n ${verbose} ]] && echo "updating ${version} from ${grubConfig}"
451   [ -n "$verbose" ] && echo "$lilo does not exist"   ${grubby} --grub -c ${grubConfig} \
452      else   --update-kernel=${bootPrefix}/${kernelName}-${version} \
453   $lilo > /dev/null   ${INITRD} \
454      fi   ${kernargs:+--args="${kernargs}"} \
455   fi   ${removeargs:+--remove-args="${removeargs}"}
456      else   else
457   [ -n "$verbose" ] && echo "$liloConfig does not exist, not running grubby"   [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"
458      fi   fi
459    
460     if [[ -n ${cfgGrub2} ]]
461     then
462     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2Config}"
463     ${grubby} --grub2 -c ${grub2Config} \
464     --update-kernel=${bootPrefix}/${kernelName}-${version} \
465     ${INITRD} \
466     ${kernargs:+--args="${kernargs}"} \
467     ${removeargs:+--remove-args="${removeargs}"}
468     else
469     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby"
470     fi
471    
472     if [[ -n ${cfgGrub2Efi} ]]
473     then
474     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2EfiConfig}"
475     ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
476     --update-kernel=${bootPrefix}/${kernelName}-${version} \
477     ${INITRD} \
478     ${kernargs:+--args="${kernargs}"} \
479     ${removeargs:+--remove-args="${removeargs}"}
480     else
481     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby"
482     fi
483    
484     if [[ -n ${cfgLilo} ]]
485     then
486     [[ -n ${verbose} ]] && echo "updating ${version} from ${liloConfig}"
487     ${grubby} --update-kernel=${bootPrefix}/${kernelName}-${version} \
488     ${INITRD} \
489     ${kernargs:+--args="${kernargs}"} \
490     ${removeargs:+--remove-args="${removeargs}"} \
491     --${liloFlag}
492    
493     if [[ -n ${runLilo} ]]
494     then
495     [[ -n ${verbose} ]] && echo "running ${lilo}"
496     if [ ! -x ${lilo} ]
497     then
498     [[ -n ${verbose} ]] && echo "${lilo} does not exist"
499     else
500     ${lilo} > /dev/null
501     fi
502     fi
503     else
504     [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
505     fi
506    
507     if [[ -n ${cfguBoot} ]]
508     then
509     [[ -n ${verbose} ]] && echo "adding $version to ${ubootDir}..."
510    
511     [[ -n ${verbose} ]] && echo "creating uImage-${version}"
512     mkimage -A arm -O linux -T kernel -C none -a ${ubootAddress} \
513     -e ${ubootAddress} -n ${version} \
514     -d ${bootPrefix}/${kernelName}-${version} ${ubootDir}/uImage-${version}
515    
516     [[ -n ${verbose} ]] && echo "creating uInitrd-${version}"
517     mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 \
518     -n initramfs -d ${initrdfile} ${ubootDir}/uInitrd-${version}
519    
520     if [ -f ${ubootDir}/uImage-${version} ] && [ -f ${ubootDir}/uInitrd-${version} ]
521     then
522     cp -fp ${ubootDir}/uImage-${version} ${ubootDir}/${ubootDefaultImage}
523     if [ $? -ne 0 ]
524     then
525     [[ -n ${verbose} ]] && echo "copy uImage-${version} error, kernel not installed!" && exit
526     fi
527     cp -fp ${ubootDir}/uInitrd-${version} ${ubootDir}/${ubootDefaultInitrd}
528     if [ $? -ne 0 ]
529     then
530     [[ -n ${verbose} ]] && echo "copy uInitrd-${version} error, kernel not installed!" && exit
531     fi
532     echo ${version} >> ${ubootDir}/${ubootKList}
533     else
534     [[ -n ${verbose} ]] && echo "cannot make ${version} the default"
535     fi
536     else
537     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not setting up ${ubootDir}"
538     fi
539    
540     if [[ -n ${cfgExtlinux} ]]
541     then
542     [[ -n ${verbose} ]] && echo "updating ${version} from ${extlinuxConfig}"
543     ${grubby} --extlinux -c ${extlinuxConfig} \
544     --update-kernel=${bootPrefix}/${kernelName}-${version} \
545     ${INITRD} \
546     ${kernargs:+--args="${kernargs}"} \
547     ${removeargs:+--remove-args="${removeargs}"}
548     else
549     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby"
550     fi
551  }  }
552    
553  mkinitrd() {  makeinitrd()
554      [ -n "$verbose" ] && echo "creating initrd $initrdfile using $version"  {
555      /sbin/mkinitrd --allow-missing -f $initrdfile $version   if [[ -n ${dracut} ]]
556      rc=$?   then
557      if [ $rc != 0 ]; then   tool="dracut ${dracuthostonly} -f ${initrdfile} ${version}"
558   echo "mkinitrd failed" >&2   else
559   exit 1   tool="mkinitrd --allow-missing -f ${initrdfile} ${version}"
560      fi   fi
561     [[ -n ${verbose} ]] && echo "creating initrd ${initrdfile} using ${version}"
562     ${tool}
563     rc=$?
564     if [ ${rc} != 0 ]
565     then
566     echo "mkinitrd failed" >&2
567     exit 1
568     fi
569  }  }
570    
571  rminitrd() {  rminitrd()
572      [ -n "$verbose" ] && echo "removing initrd $initrdfile"  {
573      [ -f $initrdfile ] && rm -f $initrdfile   [[ -n ${verbose} ]] && echo "removing initrd ${initrdfile}"
574     [ -f ${initrdfile} ] && rm -f ${initrdfile}
575  }  }
576    
577  doDepmod() {  doDepmod()
578      [ -n "$verbose" ] && echo "running depmod for $version"  {
579      depmod -ae -F /boot/System.map-$version $version   [[ -n ${verbose} ]] && echo "running depmod for ${version}"
580     depmod -ae -F /boot/System.map-${version} ${version}
581  }  }
582    
583  doRmmoddep() {  doRmmoddep()
584      [ -n "$verbose" ] && echo "removing modules.dep info for $version"  {
585      [ -d /lib/modules/$version ] && rm -f /lib/modules/$version/modules.*       [[ -n ${verbose} ]] && echo "removing modules.dep info for ${version}"
586     [ -d /lib/modules/${version} ] && rm -f /lib/modules/${version}/modules.*
587  }  }
588    
589    
590  while [ $# -gt 0 ]; do  while [ $# -gt 0 ]
591      case $1 in  do
592   --mkinitrd)   case $1 in
593      initrd="make"   --mkinitrd)
594      ;;   initrd="make"
595     ;;
596   --rminitrd)  
597      initrd="remove"   --rminitrd)
598      ;;   initrd="remove"
599     ;;
600   --initrdfile*)  
601      if echo $1 | grep '=' >/dev/null ; then   --dracut)
602       initrdfile=`echo $1 | sed 's/^--initrdfile=//'`   dracut=--dracut
603      else   ;;
604   initrdfile=$2  
605   shift   --host-only)
606      fi       dracuthostonly=-H
607      ;;   ;;
608    
609   --kernel-args*)   --initrdfile*)
610      if echo $1 | grep '=' >/dev/null ; then   if echo $1 | grep '=' >/dev/null
611       kernargs=`echo $1 | sed 's/^--kernel-args=//'`   then
612      else   initrdfile=$(echo $1 | sed 's/^--initrdfile=//')
613   kernargs=$2   else
614   shift   initrdfile=$2
615      fi       shift
616      ;;   fi
617     ;;
618   --banner*)  
619      if echo $1 | grep '=' >/dev/null ; then   --kernel-args*)
620       banner=`echo $1 | sed 's/^--banner=//'`   if echo $1 | grep '=' >/dev/null
621      else   then
622   banner=$2   kernargs=$(echo $1 | sed 's/^--kernel-args=//')
623   shift   else
624      fi       kernargs=$2
625      ;;   shift
626     fi
627   --multiboot*)   ;;
628      if echo $1 |grep '=' >/dev/null; then  
629   mbkernel=`echo $1 | sed 's/^--multiboot=//'`   --remove-args*)
630      else   if echo $1 | grep '=' >/dev/null
631   # can't really support having an optional second arg here   then
632   # sorry!   removeargs=$(echo $1 | sed 's/^--remove-args=//')
633   mbkernel="/boot/xen.gz"   else
634      fi   removeargs=$2
635      ;;   shift
636     fi
637   --mbargs*)   ;;
638      if echo $1 |grep '=' >/dev/null; then  
639   mbargs=`echo $1 | sed 's/^--mbargs=//'`   --banner*)
640      else   if echo $1 | grep '=' >/dev/null
641   mbargs=$2   then
642   shift   banner=$(echo $1 | sed 's/^--banner=//')
643      fi   else
644      ;;   banner=$2
645     shift
646   --depmod)   fi
647      moddep="make"   ;;
648      ;;  
649     --multiboot*)
650   --rmmoddep)   if echo $1 |grep '=' >/dev/null
651      moddep="remove"   then
652      ;;   mbkernel=$(echo $1 | sed 's/^--multiboot=//')
653     else
654   --make-default)   # can't really support having an optional second arg here
655      makedefault="--make-default"   # sorry!
656      ;;   mbkernel="/boot/xen.gz"
657     fi
658   --package)   ;;
659      if echo $1 | grep '=' >/dev/null ; then  
660       package=`echo $1 | sed 's/^--package=//'`   --mbargs*)
661      else   if echo $1 |grep '=' >/dev/null
662   package=$2   then
663   shift   mbargs=$(echo $1 | sed 's/^--mbargs=//')
664      fi       else
665      ;;   mbargs="$2"
666     shift
667   -v)   fi
668      verbose=-v   ;;
669      ;;  
670     --depmod)
671   *)   moddep="make"
672      if [ -z "$mode" ]; then   ;;
673   mode=$1  
674      elif [ -z "$version" ]; then   --rmmoddep)
675   version=$1   moddep="remove"
676      else   ;;
677   usage  
678      fi   --make-default)
679      ;;   makedefault="--make-default"
680      esac   ;;
681    
682     --package)
683     if echo $1 | grep '=' >/dev/null
684     then
685     package=$(echo $1 | sed 's/^--package=//')
686     else
687     package=$2
688     shift
689     fi
690     ;;
691    
692     --add-dracut-args)
693     adddracutargs=--add-dracut-args
694     ;;
695    
696     --add-plymouth-initrd)
697     addplymouthinitrd=--add-plymouth-initrd
698     ;;
699    
700     -v)
701     verbose=-v
702     ;;
703    
704     *)
705     if [[ -z ${mode} ]]
706     then
707     mode=$1
708     elif [[ -z ${version} ]]
709     then
710     version=$1
711     else
712     usage
713     fi
714     ;;
715     esac
716    
717      shift   shift
718  done  done
719    
720  # make sure the mode is valid  # make sure the mode is valid
721  if [ "$mode" != "--install" -a "$mode" != "--remove" ] ; then  if [[ ${mode} != --install ]] && [[ ${mode} != --remove ]] && [[ ${mode} != --update ]]
722      usage  then
723     usage
724  fi  fi
725    
726  if [ -z "$version" ]; then  if [[ -z ${version} ]]
727      usage  then
728     usage
729  fi  fi
730    
731  if [ "$mode" != "--install" -a "$makedefault" ]; then  if [ "${mode}" != "--install" -a "${makedefault}" ]
732      usage  then
733     usage
734  fi  fi
735    
736  # make sure that /dev/loop exist  kernelmajor=$(echo ${kernel} | cut -d . -f 1,2)
 [[ ! -e /dev/loop ]] && modprobe loop  
   
 kernelmajor=`echo $kernel | cut -d . -f 1,2`  
737    
738  # kernel image for 2.4 is vmlinux  # kernel image for 2.4 is kernel
739  if [ $ARCH = 'ppc64' -o $ARCH = 'ppc' ]; then  if [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
740    if [ "$kernelmajor" == "2.4" ]; then  then
741        kernelName=vmlinux   if [[ ${kernelmajor} = 2.4 ]]
742    fi   then
743     kernelName=kernel
744     fi
745  fi  fi
746    
   
747  # set the initrd file based on arch; ia64 is the only currently known oddball  # set the initrd file based on arch; ia64 is the only currently known oddball
748  if [ -z "$initrdfile" ]; then  if [[ -z ${initrdfile} ]]
749      if [ `uname -m` = "ia64" ]; then  then
750   initrdfile="/boot/efi/EFI/redhat/initrd-$version.img"   INITRD_NAME_PREFIX="initrd"
751      else   if [[ -n ${dracut} ]]
752   initrdfile="/boot/initrd-$version.img"   then
753      fi   INITRD_NAME_PREFIX="initramfs"
754     fi
755    
756     if [[ $(uname -m) = ia64 ]]
757     then
758     initrdfile="/boot/efi/EFI/redhat/${INITRD_NAME_PREFIX}-${version}.img"
759     else
760     initrdfile="/boot/${INITRD_NAME_PREFIX}-${version}.img"
761     fi
762  fi  fi
763  [ -n "$verbose" ] && echo "initrdfile is $initrdfile"  [[ -n ${verbose} ]] && echo "initrdfile is ${initrdfile}"
764    
765  # set this as the default if we have the package and it matches  # add dracut i18n, keyboard and plymouth kernel args if requested
766  if [ "$mode" == "--install" -a "$UPDATEDEFAULT" == "yes" -a -n "$package" -a -n "$DEFAULTKERNEL" -a "$package" == "$DEFAULTKERNEL" ]; then  if [[ -n ${dracut} ]] || [[ -n ${adddracutargs} ]]
767      makedefault="--make-default"  then
768      [ -n "$verbose" ] && echo "making it the default based on config"   if [ -r /etc/vconsole.conf ]
769  fi   then
770     . /etc/vconsole.conf
771    
772     for i in SYSFONT SYSFONTACM UNIMAP KEYTABLE
773     do
774     val=$(eval echo \$$i)
775     [[ -n ${val} ]] && kernargs="${kernargs} ${i}=${val}"
776     done
777     else
778     if [ -r /etc/conf.d/consolefont ]
779     then
780     . /etc/conf.d/consolefont
781    
782     if [[ -n ${CONSOLEFONT} ]]
783     then
784     kernargs="${kernargs} SYSFONT=${CONSOLEFONT}"
785     fi
786     fi
787    
788     if  [ -r /etc/conf.d/keymap ]
789     then
790     . /etc/conf.d/keymap
791    
792     if [[ -n ${KEYMAP} ]]
793     then
794     kernargs="${kernargs} KEYTABLE=${KEYMAP}"
795     fi
796     fi
797     fi
798    
799  if [ "$moddep" == "make" ]; then   if [ -r /etc/locale.conf ]
800      doDepmod   then
801  elif [ "$moddep" == "remove" ]; then   . /etc/locale.conf
802      doRmmoddep  
803     if [[ -n ${LANG} ]]
804     then
805     kernargs="${kernargs} LANG=${LANG}"
806     fi
807     fi
808  fi  fi
809    
810  if [ "$initrd" == "make" ]; then  # set this as the default if we have the package and it matches
811      mkinitrd  if [[ ${mode} = --install ]] && [[ ${UPDATEDEFAULT} = yes ]] && [[ -n ${package} ]] &&
812  elif [ "$initrd" == "remove" ]; then   [[ -n ${DEFAULTKERNEL} ]] && [[ ${package} = ${DEFAULTKERNEL} ]]
813      rminitrd  then
814     makedefault="--make-default"
815     [[ -n ${verbose} ]] && echo "making it the default based on config"
816    fi
817    
818    if [[ ${moddep} = make ]]
819    then
820     doDepmod
821    elif [[ ${moddep} = remove ]]
822    then
823     doRmmoddep
824    fi
825    
826    if [[ ${initrd} = make ]]
827    then
828     makeinitrd
829    elif [[ ${initrd} = remove ]]
830    then
831     rminitrd
832    fi
833    
834    if [ ! -x ${grubby} ]
835    then
836     [[ -n ${verbose} ]] && echo "${grubby} does not exist"
837     exit 0
838    fi
839    
840    [[ -n ${grubConfig} ]] && [ -f ${grubConfig} ] && cfgGrub=1
841    [[ -n ${grub2Config} ]] && [ -f ${grub2Config} ] && cfgGrub2=1
842    [[ -n ${grub2EfiConfig} ]] && [ -f ${grub2EfiConfig} ] && cfgGrub2Efi=1
843    [[ -n ${liloConfig} ]] && [ -f ${liloConfig} ] && cfgLilo=1
844    [[ -n ${extlinuxConfig} ]] && [ -f ${extlinuxConfig} ] && cfgExtlinux=1
845    
846    # if we have a U-Boot directory, but no boot script, check if the directory
847    # is mounted.  If not, mount it, and then check if a boot script exists.
848    if [[ -n ${ubootDir} ]]
849    then
850     if [ -f ${ubootScript} ]
851     then
852     cfguBoot=1
853     else
854     mountEntry=$(mount | grep ${ubootDir})
855     if [[ -z ${mountEntry} ]]
856     then
857     mount ${ubootDevice} ${ubootDir}
858     mounted=1
859     fi
860     [ -f ${ubootScript} ] && cfguBoot=1
861     fi
862  fi  fi
863    
864  if [ ! -x $grubby ] ; then  # if we're using U-Boot, check if the default load address should change
865      [ -n "$verbose" ] && echo "$grubby does not exist"  if [[ -n ${cfguBoot} ]] && [[ -z ${UBOOT_IMGADDR} ]]
866      exit 0  then
867     [[ ${version}  =~ .([^.]*)$ ]]
868     platform=${BASH_REMATCH[1]}
869     # A few platforms use an alternate kernel load address
870     if [[ ${platform} = omap ]]
871     then
872     ubootAddress=0x80008000
873     elif [[ ${platform} = imx ]]
874     then
875     ubootAddress=0x90008000
876     fi
877  fi  fi
878    
   
 [ -n "$grubConfig" ] && [ -f "$grubConfig" ] && cfgGrub=1;  
 [ -n "$liloConfig" ] && [ -f "$liloConfig" ] && cfgLilo=1;  
   
879  # if we have a lilo config on an x86 box, see if the default boot loader  # if we have a lilo config on an x86 box, see if the default boot loader
880  # is lilo to determine if it should be run  # is lilo to determine if it should be run
881  if [ -n "$cfgLilo" -a -n "$isx86" ]; then  if [[ -n ${cfgLilo} ]] && [[ -n ${isx86} ]]
882      runLilo=$($grubby --bootloader-probe | grep lilo)  then
883     runLilo=$(${grubby} --bootloader-probe | grep lilo)
884    fi
885    
886    if [[ ${mode} = --install ]]
887    then
888     install
889    elif [[ ${mode} = --remove ]]
890    then
891     remove
892    elif [[ ${mode} = --update ]]
893    then
894     update
895  fi  fi
896    
897  if [ "$mode" == "--install" ]; then  # if we mounted the U-Boot directory, unmount it.
898      install  [[ -n ${mounted} ]] && umount ${ubootDir}
 elif [ "$mode" == "--remove" ]; then  
     remove  
 fi  
899    
900  exit 0  exit 0

Legend:
Removed from v.532  
changed lines
  Added in v.2239